import { createRoute, OpenAPIHono, z } from "@hono/zod-openapi";
import { responses } from "../../../globalUtils/routeDefs/responses.js";
import { tryCatch } from "../../../globalUtils/tryCatch.js";
import { apiHit } from "../../../globalUtils/apiHits.js";
import { psiGetPlanningData } from "../controller/psiGetPlanningData.js";
import { getForecastByAv } from "../controller/forecastByAvs.js";

const app = new OpenAPIHono({ strict: false });
const Body = z.object({
    includeRunnningNumbers: z.string().openapi({ example: "x" }),
});
app.openapi(
    createRoute({
        tags: ["dataMart"],
        summary: "Returns the psiarticleData.",
        method: "get",
        path: "/forecastbyav",
        request: {
            body: {
                content: {
                    "application/json": { schema: Body },
                },
            },
        },
        responses: responses(),
    }),
    async (c) => {
        const q: any = c.req.queries();

        // make sure we have a vaid user being accessed thats really logged in
        apiHit(c, { endpoint: "/forecastbyav" });
        //console.log(articles["avs"][0]);
        const { data, error } = await tryCatch(
            getForecastByAv(q["avs"] ? q["avs"][0] : null)
        );

        if (error) {
            console.log(error);
            return c.json(
                {
                    success: false,
                    message: "There was an error getting the forecast data.",
                    data: error,
                },
                400
            );
        }

        //console.log(data);

        return c.json(
            {
                success: data.success,
                message: data.message,
                data: data.data,
            },
            data.success ? 200 : 400
        );
    }
);
export default app;
